|  | Home · All Classes · Main Classes · Grouped Classes · Modules · Functions |

# cannonfield.h Example File
tutorial/t12/cannonfield.h

     /****************************************************************************
     **
     ** Copyright (C) 2005-2006 Trolltech ASA. All rights reserved.
     **
     ** This file is part of the example classes of the Qt Toolkit.
     **
     ** This file may be used under the terms of the GNU General Public
     ** License version 2.0 as published by the Free Software Foundation
     ** and appearing in the file LICENSE.GPL included in the packaging of
     ** this file.  Please review the following information to ensure GNU
     ** General Public Licensing requirements will be met:
     ** http://www.trolltech.com/products/qt/opensource.html
     **
     ** If you are unsure which license is appropriate for your use, please
     ** review the following information:
     ** http://www.trolltech.com/products/qt/licensing.html or contact the
     ** sales department at sales@trolltech.com.
     **
     ** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
     ** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
     **
     ****************************************************************************/

     #ifndef CANNON_H
     #define CANNON_H

     #include <QWidget>

     class QTimer;

     class CannonField : public QWidget
     {
         Q_OBJECT

     public:
         CannonField(QWidget *parent = 0);

         int angle() const { return currentAngle; }
         int force() const { return currentForce; }

     public slots:
         void setAngle(int angle);
         void setForce(int force);
         void shoot();
         void newTarget();

     private slots:
         void moveShot();

     signals:
         void hit();
         void missed();
         void angleChanged(int newAngle);
         void forceChanged(int newForce);

     protected:
         void paintEvent(QPaintEvent *event);

     private:
         void paintShot(QPainter &painter);
         void paintTarget(QPainter &painter);
         void paintCannon(QPainter &painter);
         QRect cannonRect() const;
         QRect shotRect() const;
         QRect targetRect() const;

         int currentAngle;
         int currentForce;

         int timerCount;
         QTimer *autoShootTimer;
         float shootAngle;
         float shootForce;

         QPoint target;
     };

     #endif